## u-config 0.33.3

=== Makefile ===
CROSS = x86_64-w64-mingw32-
CC    = gcc
OPT   = -Os
PC    = pkg-config  # e.g. for CROSS-pkg-config

DEBUG_CFLAGS = -g3 -Wall -Wextra -Wconversion -Wno-sign-conversion \
  -fsanitize=undefined -fsanitize-undefined-trap-on-error
WIN32_CFLAGS = -fno-builtin -fno-asynchronous-unwind-tables
WIN32_LIBS   = -s -nostdlib -Wl,--gc-sections -lkernel32
LINUX_CFLAGS = -fno-builtin -fno-pie -fno-asynchronous-unwind-tables
LINUX_LIBS   = -static -s -no-pie -nostdlib -Wl,--gc-sections

pkg-config.exe: win32_main.c cmdline.c miniwin32.h u-config.c
	$(CROSS)$(CC) $(OPT) $(WIN32_CFLAGS) -o $@ win32_main.c $(WIN32_LIBS)

pkg-config-debug.exe: win32_main.c cmdline.c miniwin32.h u-config.c
	$(CROSS)$(CC) -nostartfiles $(DEBUG_CFLAGS) -o $@ win32_main.c

# Auto-configure using the system's pkg-config search path
pkg-config: generic_main.c u-config.c
	$(CC) $(OPT) -o $@ generic_main.c \
	  -DPKG_CONFIG_LIBDIR="\"$$($(PC) --variable pc_path pkg-config)\""

pkg-config-debug: generic_main.c u-config.c
	$(CC) $(DEBUG_CFLAGS) -o $@ generic_main.c

# Auto-configure using the system's pkg-config search path
pkg-config-linux-amd64: linux_amd64_main.c linux_noarch.c u-config.c
	$(CC) $(OPT) $(LINUX_CFLAGS) -o $@ linux_amd64_main.c $(LINUX_LIBS) \
	  -DPKG_CONFIG_LIBDIR="\"$$($(PC) --variable pc_path pkg-config)\""

pkg-config-linux-amd64-debug: linux_amd64_main.c linux_noarch.c u-config.c
	$(CC) -nostdlib -fno-builtin $(DEBUG_CFLAGS) -o $@ linux_amd64_main.c

# Auto-configure using the system's pkg-config search path
pkg-config-linux-i686: linux_i686_main.c linux_noarch.c u-config.c
	$(CC) $(OPT) $(LINUX_CFLAGS) -o $@ linux_i686_main.c $(LINUX_LIBS) \
	  -DPKG_CONFIG_LIBDIR="\"$$($(PC) --variable pc_path pkg-config)\""

pkg-config-linux-i686-debug: linux_i686_main.c linux_noarch.c u-config.c
	$(CC) -nostdlib -fno-builtin $(DEBUG_CFLAGS) -o $@ linux_i686_main.c

# Concatenate Windows-only u-config into a single source file
amalgamation: pkg-config.c
pkg-config.c: u-config.c miniwin32.h cmdline.c win32_main.c
	awk 'n{print"";n=0} NR==3{printf"%s\n",cc} !/^#i.*"/{print}' \
	    cc='//   $$ cc -nostartfiles -o pkg-config.exe pkg-config.c' \
	    >$@ u-config.c n=1 miniwin32.h n=1 cmdline.c n=1 win32_main.c

release:
	version=$$(git describe); prefix=u-config-$${version#v}; \
	  git archive --prefix=$$prefix/ HEAD | gzip -9 >$$prefix.tar.gz

tests.exe: test_main.c u-config.c
	$(CROSS)$(CC) $(DEBUG_CFLAGS) -Wno-clobbered -o $@ test_main.c

tests: test_main.c u-config.c
	$(CC) $(DEBUG_CFLAGS) -Wno-clobbered -o $@ test_main.c

check test: tests$(EXE)
	./tests$(EXE)

# Build and install into w64devkit
install: win32_main.c cmdline.c miniwin32.h u-config.c
	$(CROSS)$(CC) $(OPT) $(WIN32_CFLAGS) win32_main.c \
	  -DPKG_CONFIG_PREFIX="\"/$$(gcc -dumpmachine)\"" \
	  -o $(W64DEVKIT_HOME)/bin/pkg-config.exe $(WIN32_LIBS)

clean:
	rm -f pkg-config.exe pkg-config-debug.exe \
	      pkg-config pkg-config-debug \
	      pkg-config-linux-amd64 pkg-config-linux-amd64-debug \
	      pkg-config-linux-i686 pkg-config-linux-i686-debug \
	      pkg-config.c u-config-*.tar.gz \
	      tests.exe tests \
	      *.ilk *.obj *.pdb test_main.exe

## u-config 0.33.1

=== debian/changelog ===
u-config (0.33.1-2) unstable; urgency=medium

  * First dgit upload
  * d/rules: fix cross builds.
    Including buildtools.mk makes the CC make variable point to the correct
    compiler when cross compiling, which in turn makes system-libdirs.sh
    output the correct system paths.
  * d/rules: build tests during dh_auto_build

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 08 Sep 2024 22:48:02 +0200

u-config (0.33.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1080307)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 03 Sep 2024 10:56:56 +0200

=== debian/control ===
Source: u-config
Section: devel
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-single-binary,
 dpkg-build-api (= 1),
Standards-Version: 4.7.0
Homepage: https://github.com/skeeto/u-config
Vcs-Git: https://salsa.debian.org/tachi/u-config.git
Vcs-Browser: https://salsa.debian.org/tachi/u-config
X-Style: black

Package: u-config
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: smaller, simpler, portable pkg-config clone
 u-config ("micro-config") is a small, highly portable pkg-config and
 pkgconf clone.
 .
 It is a fraction of the size while retaining the core, user-level
 features of pkg-config and pkgconf. It is also highly portable,
 supporting a variety of compilers and operating systems; it can even be
 built without libc.
 .
 u-config focuses on supporting existing pkg-config based builds, while
 omitting developer-level features like debugging options. It also adds
 some unique features, like the possibility of separating arguments by
 line feeds instead of spaces, and better handling of spaces in file
 paths.

=== debian/watch ===
version=4
opts="searchmode=plain, pgpsigurlmangle=s/$/.sig/" \
https://api.github.com/repos/skeeto/u-config/releases \
https://github.com/skeeto/u-config/releases/download/[^/]+/u-config-@ANY_VERSION@.tar.gz

## u-config 0.33.3

=== debian/changelog ===
u-config (0.33.3-1) unstable; urgency=low

  * New upstream version 0.33.3
  * d/control: use my @debian.org email address
  * d/copyright: set Upstream-Contact to ~skeeto/public-inbox
  * d/patches: drop upstreamed patches

 -- Andrea Pappacoda <tachi@debian.org>  Sat, 22 Mar 2025 16:31:40 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: u-config
 Section: devel
 Priority: optional
-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
+Maintainer: Andrea Pappacoda <tachi@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  dh-sequence-single-binary,
  dpkg-build-api (= 1),
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/skeeto/u-config
 Vcs-Git: https://salsa.debian.org/tachi/u-config.git
 Vcs-Browser: https://salsa.debian.org/tachi/u-config

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildtools.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all qa=+all

# From pkgconf packaging
SYSTEM_LIBDIRS := $(shell sh debian/system-libdirs.sh $(CC))

%:
	dh $@ --buildsystem=none

override_dh_auto_build:
	$(CC) \
		-DPKG_CONFIG_LIBDIR='"/usr/local/lib/$(DEB_HOST_MULTIARCH)/pkgconfig:/usr/local/lib/pkgconfig:/usr/local/share/pkgconfig:/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig:/usr/lib/pkgconfig:/usr/share/pkgconfig"' \
		-DPKG_CONFIG_SYSTEM_LIBRARY_PATH='"$(SYSTEM_LIBDIRS)"' \
		$(CPPFLAGS) \
		$(CFLAGS) \
		$(LDFLAGS) \
		-o u-config \
		generic_main.c
	$(MAKE) tests CC=$(CC) DEBUG_CFLAGS="$(CFLAGS) $(CPPFLAGS) $(LDFLAGS)"

override_dh_auto_test:
	$(MAKE) check

override_dh_auto_clean:
	$(RM) u-config tests

## u-config 0.34.0

=== Makefile ===
# NOTE TO DISTRIBUTION PACKAGE MAINTAINERS: The targets in this Makefile
# are intended only for development, testing, and evaluation. If you are
# packaging u-config for a distribution, invoke a compiler directly on
# the appropriate main_*.c source. See "Build" in README.md for more
# information, and "Configuration" for a list of configuration options.

CROSS = x86_64-w64-mingw32-
CC    = gcc
OPT   = -Os
PC    = pkg-config  # e.g. for CROSS-pkg-config

DEBUG_CFLAGS = -g3 -Wall -Wextra -Wconversion \
  -fsanitize=undefined -fsanitize-undefined-trap-on-error
WIN32_CFLAGS = -fno-builtin -fno-asynchronous-unwind-tables
WIN32_LIBS   = -s -nostdlib -Wl,--gc-sections -lkernel32
LINUX_CFLAGS = -fno-builtin -fno-pie -fno-asynchronous-unwind-tables
LINUX_LIBS   = -static -s -no-pie -nostdlib -Wl,--gc-sections

default:
	@echo 'No sensible default target. Makefile is intended for development'
	@echo 'and testing. See "Build" and "Configuration" in README.md. Use the'
	@echo '"pkg-config" target to copy your system pkg-config configuration'
	@echo 'for evaluation and comparison.'
	@exit 1

src_windows = src/cmdline.c src/miniwin32.h src/u-config.c
src_linux   = src/linux_noarch.c src/u-config.c

pkg-config.exe: main_windows.c $(src_windows)
	$(CROSS)$(CC) $(OPT) $(WIN32_CFLAGS) -o $@ main_windows.c $(WIN32_LIBS)

pkg-config-debug.exe: main_windows.c $(src_windows)
	$(CROSS)$(CC) -nostartfiles $(DEBUG_CFLAGS) -o $@ main_windows.c

# Auto-configure using the system's pkg-config search path
pkg-config: main_posix.c src/u-config.c
	$(CC) $(OPT) -o $@ main_posix.c \
	  -DPKG_CONFIG_LIBDIR="\"$$($(PC) --variable pc_path pkg-config)\""

pkg-config-debug: main_posix.c src/u-config.c
	$(CC) $(DEBUG_CFLAGS) -o $@ main_posix.c

# Auto-configure using the system's pkg-config search path
pkg-config-linux-amd64: main_linux_amd64.c $(src_linux)
	$(CC) $(OPT) $(LINUX_CFLAGS) -o $@ main_linux_amd64.c $(LINUX_LIBS) \
	  -DPKG_CONFIG_LIBDIR="\"$$($(PC) --variable pc_path pkg-config)\""

pkg-config-linux-amd64-debug: main_linux_amd64.c $(src_linux)
	$(CC) -nostdlib -fno-builtin $(DEBUG_CFLAGS) -o $@ main_linux_amd64.c

# Auto-configure using the system's pkg-config search path
pkg-config-linux-i686: main_linux_i686.c $(src_linux)
	$(CC) $(OPT) $(LINUX_CFLAGS) -o $@ main_linux_i686.c $(LINUX_LIBS) \
	  -DPKG_CONFIG_LIBDIR="\"$$($(PC) --variable pc_path pkg-config)\""

pkg-config-linux-i686-debug: main_linux_i686.c $(src_linux)
	$(CC) -nostdlib -fno-builtin $(DEBUG_CFLAGS) -o $@ main_linux_i686.c

# Concatenate Windows-only u-config into a single source file
amalgamation: pkg-config.c
pkg-config.c: main_windows.c $(src_windows)
	awk 'n{print"";n=0} NR==3{printf"%s\n",cc} !/^#i.*"/{print}' \
	    cc='//   $$ cc -nostartfiles -o pkg-config.exe pkg-config.c' \
	    >$@ src/u-config.c  n=1 \
	        src/miniwin32.h n=1 \
	        src/cmdline.c   n=1 \
	        main_windows.c

release:
	version=$$(git describe); prefix=u-config-$${version#v}; \
	  git archive --prefix=$$prefix/ HEAD | gzip -9 >$$prefix.tar.gz

tests.exe: main_test.c src/u-config.c
	$(CROSS)$(CC) $(DEBUG_CFLAGS) -Wno-clobbered -o $@ main_test.c

tests: main_test.c src/u-config.c
	$(CC) $(DEBUG_CFLAGS) -Wno-clobbered -o $@ main_test.c

pkg-config.wasm: main_wasm.c src/u-config.c
	clang --target=wasm32 -nostdlib -Os -mbulk-memory \
	      -Wall -Wextra -Wconversion -Wno-unused-parameter \
	      -s -Wl,--stack-first -o $@ main_wasm.c

check test: tests$(EXE)
	./tests$(EXE)

# Build and install into w64devkit
install: main_windows.c $(src_windows)
	$(CROSS)$(CC) $(OPT) $(WIN32_CFLAGS) main_windows.c \
	  -DPKG_CONFIG_PREFIX="\"/$$(gcc -dumpmachine)\"" \
	  -o $(W64DEVKIT_HOME)/bin/pkg-config.exe $(WIN32_LIBS)

clean:
	rm -f pkg-config.exe pkg-config-debug.exe \
	      pkg-config pkg-config-debug \
	      pkg-config-linux-amd64 pkg-config-linux-amd64-debug \
	      pkg-config-linux-i686 pkg-config-linux-i686-debug \
	      pkg-config.c u-config-*.tar.gz \
	      tests.exe tests pkg-config.wasm \
	      *.ilk *.obj *.pdb main_test.exe

=== debian/changelog ===
u-config (0.34.0-1) experimental; urgency=low

  * New upstream version 0.34.0
  * d/rules: use POSIX platform layer

 -- Andrea Pappacoda <tachi@debian.org>  Thu, 08 May 2025 15:57:19 +0200

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,7 @@
 		$(CFLAGS) \
 		$(LDFLAGS) \
 		-o u-config \
-		generic_main.c
+		main_posix.c
 	$(MAKE) tests CC=$(CC) DEBUG_CFLAGS="$(CFLAGS) $(CPPFLAGS) $(LDFLAGS)"
 
 override_dh_auto_test:

=== debian/tests/control ===
Tests: external
Depends: @, libssl-dev

Tests: selfcheck
Depends: @
